// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

// All implementing classes should have a name of 
// "ClassMenu" + ...  

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import com.togethersoft.openapi.ide.IdeContext;
import com.togethersoft.openapi.ide.window.IdeDialogType;
import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.rwi.*;

import de.uka.ilkd.key.casetool.UMLModelClass;
import de.uka.ilkd.key.casetool.together.TogetherModelClass;

import javax.swing.ProgressMonitor;



public abstract class  ClassMenu {

    protected ProgressMonitor pm;

    public abstract String getMenuEntry();

    public void run(IdeWindowManager winMan, IdeContext context, 
		    RwiModel rwiModel, RwiDiagram rwiDiagram){
	RwiElement[] selectedRwiElements = context.getRwiElements();
	RwiElement selectedRwiElement = selectedRwiElements[0];
	RwiReference selectedRef = rwiDiagram.findReference(selectedRwiElement);
	// if a class is selected it is always a node (so the cast
	// shouldn't be dangerous
	RwiNode selectedNode = ((RwiNodeReference) selectedRef).getNode();

	TogetherModelClass modelClass 
		= new TogetherModelClass(selectedNode, rwiModel, rwiDiagram);

	String result = runCore(modelClass);

	if (!result.equals("")){
            if (pm!=null) pm.close();
	    winMan.showMessageDialog("Result", IdeDialogType.INFORMATION, result);
	}
    }

    protected abstract String runCore(UMLModelClass aReprModelClass);
}
