// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.strategy;

import de.uka.ilkd.key.proof.Goal;
import de.uka.ilkd.key.proof.NewRuleListener;
import de.uka.ilkd.key.rule.RuleApp;


/**
 *
 */
public interface AutomatedRuleApplicationManager extends NewRuleListener {
    
    /**
     * Clear existing caches of applicable rules
     */
    void clearCache ();

    AutomatedRuleApplicationManager copy ();

    RuleApp nextAndCache();
    
    /**
     * @return the next rule that is supposed to be applied
     */
    RuleApp next();

    /**
     * Set the goal <code>this</code> is the rule app manager for
     */
    void setGoal ( Goal p_goal );

}
